; https://forum.bricsys.com/discussion/35942/select-solids-by-face-color?

; Typical sub:
; (1 . "truecolor-adesk-attrib $-1 -1 $13 $-1 $8 -1023410174 #")

; (GetSubColorNumber (car (entsel)))
(defun GetSubColorNumber (enm)
  (vl-some
    '(lambda (sub / clr)
      (and
        (= 1 (car sub))
        (wcmatch (cdr sub) "truecolor-adesk-attrib*")
        (setq clr (atoi (cadr (reverse (vle-string-split " " (cdr sub))))))
        (vl-position (lsh clr -24) (list accolormethodbyaci accolormethodbyrgb))
      )
      clr
    )
    (entget enm)
  )
)

(defun c:SelectSolidsWithSubColor ( / clr enm)
  (if
    (and
      (setq enm (car (entsel)))
      (= "3DSOLID" (vle-entget 0 enm))
      (setq clr (GetSubColorNumber enm))
    )
    (sssetfirst nil (ssget "_X" (list (cons 1 (strcat "truecolor-adesk-attrib*" (itoa clr) " `#")))))
  )
  (princ)
)
